import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class DomoJava extends Applet implements Runnable 
{
	Thread thrHilo=null; // el hilo donde se ejecutar el applet
	Dimension d; // para conocer el tamao del applet
	Color colColor; // para establecer el color de fondo
	Image imgPantalla,imgEncender,imgApagar; // El Buffer de pantalla y las imagenes
	Graphics graPantalla; // El Grafico del Buffer de Pantalla
	Socket sckCliente; // El socket que se conectar al servidor
	String strParametros[]; // Array donde se alacenan los aparatos
	InputStream inpRecibe; // Entrada del socket
	OutputStream outEnvia; // Salida del socket
	byte bytEstado=0; // Estado para dibujar en la Pantalla

	public void start()
	{
		// Creamos el hilo cuando empezamos
		if(thrHilo==null)
		{
			thrHilo=new Thread(this);
			thrHilo.start();
		}
	}

	public void stop()
	{
		// Quitamos el hilo cuando terminamos
		if(thrHilo!=null)
		{
			thrHilo.stop();
			thrHilo=null;
		}
	}
	
	public void run()
	{
		byte bytArray[]=new byte[1024]; // Donde se almacena lo que se recibe
		String strCadena; // Donde se guarda la cadena recibida

		for(;;)
		{
			try
			{
				if(inpRecibe.available()>0) // Preguntamos si hay datos
				{
					int intCuantos=inpRecibe.read(bytArray);
					strCadena=new String(bytArray);
					strCadena=strCadena.substring(0,intCuantos); // Se guarda la cadena
					do
					{
						// Se sigue la lgica del protocolo
						if(strCadena.substring(0,3).compareTo("100")==0)
							outEnvia.write(new String("USER:" + getParameter("login") + "\r\n").getBytes());
						else if(strCadena.substring(0,3).compareTo("200")==0)
							outEnvia.write(new String("PASS:"+ getParameter("password") + "\r\n").getBytes());
						else if(strCadena.substring(0,3).compareTo("101")==0)
							bytEstado=(byte)Integer.parseInt(strCadena.substring(4,strCadena.indexOf("\r\n")));
						strCadena=strCadena.substring(strCadena.indexOf("\r\n")+2,strCadena.length());
					}while(strCadena.length()>0); // Por si existen ms cadenas a tratar
				}
			}
			catch(Exception a)
			{
			}
			repaint(); // Redibujamos la pantalla
			try
			{
				Thread.sleep(500); // Damos un periodo de espera suficiente
			}
			catch(InterruptedException a)
			{
			}
		}
	}
	
	public void init()
	{
		d=this.size();
		// Cargamos las imgenes
		imgEncender=getImage(getCodeBase(),"encender.gif");
		imgApagar=getImage(getCodeBase(),"apagar.gif");
		// Creamos el Buffer de Pantalla
		imgPantalla=createImage(d.width,d.height);
		graPantalla=imgPantalla.getGraphics();
		// Recogemos los distintos aparatos
		strParametros=new String[4];
		strParametros[0]=getParameter("uno");
		strParametros[1]=getParameter("dos");
		strParametros[2]=getParameter("tres");
		strParametros[3]=getParameter("cuatro");
		// Configuramos la presentacin
		graPantalla.setFont(new Font("Arial",0,20));
		colColor=new Color(Integer.parseInt(getParameter("color")));
		try
		{
			// Nos conectamos al servidor
			sckCliente=new Socket(getParameter("ip"),1976);
			inpRecibe=sckCliente.getInputStream();
			outEnvia=sckCliente.getOutputStream();
		}
		catch(UnknownHostException a)
		{
		}
		catch(IOException a)
		{
		}
	}
	
	public void paint(Graphics g)
	{
		int intContador;
		// Pintamos la pantalla
		graPantalla.setColor(colColor);
		graPantalla.fillRect(0,0,d.width,d.height);
		graPantalla.setColor(Color.black);
		for(intContador=0;intContador<strParametros.length;intContador++)
		{
			graPantalla.drawString(strParametros[intContador],80,intContador*80+40);
			graPantalla.drawImage(((bytEstado & (int)Math.pow(2,intContador))==0)?imgEncender:imgApagar,0,intContador*80,this);
		}
		g.drawImage(imgPantalla,0,0,this);
	}
	
	public void update(Graphics g)
	{
		paint(g);
	}
	
	public boolean mouseUp( Event evt, int x, int y )
	{
		int intContador;
		byte bytMascara;
		try
		{
			// Comprobamos que botn ha sido pulsado y enviamos la orden
			for(intContador=0;intContador<strParametros.length;intContador++)
				if(x>=0 && x<=75 && y>=intContador*80 && y<=intContador*80+75)
				{
					bytMascara=(byte)Math.pow(2,intContador);
					outEnvia.write(new String(Integer.toString((~bytEstado & bytMascara) | (bytEstado & ~bytMascara))+"\r\n").getBytes());
				}
		}
		catch(IOException a)
		{
		}
		return true;
	}

}
